--
-- List probe: url_response profile and list:
--     profile name
--     active (yes,no)
--     url
--
-- Logic:
--    - sql query to obtain the address of all robots with an url_response
--    - get_config on each of these robots
--    - print only relevant fields
-- 
-- Luc Christiaens - CA - 30/09/2016
--

-- when running NOT under nas we need a logon
--nimbus.login("administrator", "xxx")

-- specify output file
csv  = "c:/temp/get_url_response_config.csv"

-- variables
remove_profile="/profiles/"

-- Creates/overwrites the output CSV file
file.create (csv)

-- Write first line with titles in CSV
file.write (csv,"address,group,profile_name,active,url\n")

-- open sql db
database.open("provider=nis;database=nis;driver=none") 

-- sql query to get probes with url_response (fields robot or address
sSql = "SELECT address FROM CM_NIMBUS_ROBOT where robot_id in (select robot_id from CM_NIMBUS_PROBE where probe_name = 'url_response')"
tRtables = database.query(sSql )

-- now iterate over all rows 
for iIx, tRow in pairs(tRtables) do
  print( "url_response address: "..tRow["address"] )
  addr1=tRow["address"]
  args = pds.create()
--  print ("Processing robot: " .. addr1 .. "")
  pds.putString(args,"name","url_response")
  probe_config_get = nimbus.request(addr1.."/controller","probe_config_get",args)
  if probe_config_get ~= nil then
     for section,tableid in pairs(probe_config_get) do
         match1 = regexp( section, "/\/profiles\//")
         if match1 == true then
--          print("section: ",section,"") 
            for key,value in pairs(probe_config_get[section]) do 
              if value ~= nil then
-- print only url
--            print(" key: ",key," value: ",value,"")
                if key == "url" then 
                   url=value
                   profile=section  
                   profile=profile:gsub(remove_profile,"")
                   urlseen="y"                             
--                 print(" saved profile: ",section," url: ",value,"")
                end
                if key == "active" then 
                   act=value
                end 
                if key == "group" then 
                  group=value
                   if urlseen == "y" then
--                      print("address: ",addr1," group: ",group," profile: ",profile," active: ",value," url: ",url,"")
                      file.write (csv,addr1..","..group..","..profile..","..act..","..url.."\n")
                      urlseen=n
                   end
                end
              end
            end 
         end
     end
 end
end

-- close db
database.close()

-- normal end
print (" ")
print ("--- Normal end of processes script ---")

